"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Read(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
        "quality",
        "sequence",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.sequence.Read": opencb_2_9_3.Read,
        }

    __slots__ = [
        "id",
        "quality",
        "sequence",
    ]

    def __init__(
        self,
        id,
        quality,
        sequence,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.Read model.

        :param id:
            The read ID.
        :type id: str
        :param quality:
            The full read quality.
        :type quality: str
        :param sequence:
            The full read sequence.
        :type sequence: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
